<?php

    if ( ! class_exists( 'weLaunch' ) && ! class_exists( 'Redux' ) ) {
        return;
    }

    if( class_exists( 'weLaunch' ) ) {
        $framework = new weLaunch();
    } else {
        $framework = new Redux();
    }
    // This is your option name where all the Redux data is stored.
    $opt_name = "woocommerce_quick_order_options";

    $args = array(
        'opt_name' => 'woocommerce_quick_order_options',
        'use_cdn' => TRUE,
        'dev_mode' => FALSE,
        'display_name' => 'WooCommerce Quick Order',
        'display_version' => '1.4.6',
        'page_title' => 'WooCommerce Quick Order',
        'update_notice' => TRUE,
        'intro_text' => '',
        'footer_text' => '&copy; '.date('Y').' weLaunch',
        'admin_bar' => false,
        'menu_type' => 'submenu',
        'menu_title' => 'Quick Order',
        'allow_sub_menu' => TRUE,
        'page_parent' => 'woocommerce',
        'page_parent_post_type' => 'your_post_type',
        'customizer' => FALSE,
        'default_mark' => '*',
        'hints' => array(
            'icon_position' => 'right',
            'icon_color' => 'lightgray',
            'icon_size' => 'normal',
            'tip_style' => array(
                'color' => 'light',
            ),
            'tip_position' => array(
                'my' => 'top left',
                'at' => 'bottom right',
            ),
            'tip_effect' => array(
                'show' => array(
                    'duration' => '500',
                    'event' => 'mouseover',
                ),
                'hide' => array(
                    'duration' => '500',
                    'event' => 'mouseleave unfocus',
                ),
            ),
        ),
        'output' => TRUE,
        'output_tag' => TRUE,
        'settings_api' => TRUE,
        'cdn_check_time' => '1440',
        'compiler' => TRUE,
        'page_permissions' => 'manage_options',
        'save_defaults' => TRUE,
        'show_import_export' => TRUE,
        'database' => 'options',
        'transient_time' => '3600',
        'network_sites' => TRUE,
    );

    $tableData = array(
        'enabled' => array(
            'mc' => __('Multiple CB Add Cart', 'woocommerce-quick-order'),
            'im' => __('Image', 'woocommerce-quick-order'),
            'pt' => __('Name', 'woocommerce-quick-order'),
            'sk' => __('SKU', 'woocommerce-quick-order'),
            'pr' => __('Price', 'woocommerce-quick-order'),
            'st' => __('Stock', 'woocommerce-quick-order'),
            // 'at' => __('Attributes', 'woocommerce-quick-order'),
            'ca' => __('Add to Cart', 'woocommerce-quick-order'),
        ),
        'disabled' => array(
            'mq' => __('Multiple QT Add Cart', 'woocommerce-quick-order'),
            'qt' => __('Quantity', 'woocommerce-quick-order'),
            'rm' => __('Read More', 'woocommerce-quick-order'),
            'ct' => __('Category', 'woocommerce-quick-order'),
            'de' => __('Short Description', 'woocommerce-quick-order'),
            'di' => __('Dimensions', 'woocommerce-quick-order'),
            'we' => __('Weight', 'woocommerce-quick-order'),
            'pd' => __('Export PDF *', 'woocommerce-quick-order'),
            'eq' => __('Enquiry **', 'woocommerce-quick-order'),
            'wi' => __('Wishlist ***', 'woocommerce-quick-order'),
        )
    );

    // Get Custom Meta Keys for product
    $transient_name = 'woocommerce_quick_order_meta_keys';
    $woocommerce_quick_order_meta_keys = get_transient( $transient_name );

    $currentOptions = get_option($opt_name);
    if( isset($currentOptions['tableMetaData']) && $currentOptions['tableMetaData'] == "1" ) {
        
        if (false === $woocommerce_quick_order_meta_keys ) { 

            // Get Custom Meta Keys for post
            global $wpdb;
            $sql = "SELECT DISTINCT meta_key
                            FROM " . $wpdb->postmeta . "
                            INNER JOIN  " . $wpdb->posts . " 
                            ON post_id = ID
                            WHERE post_type = 'product' OR post_type ='product_variation'
                            ORDER BY meta_key ASC";

            $meta_keys = $wpdb->get_results( $sql, 'ARRAY_A' );
            $meta_keys_to_exclude = array('_crosssell_ids', '_children', '_default_attributes', '_height', '_length', '_weight', '_width');

            $meta_keys_rearranged = array();
            foreach ($meta_keys as $key => $meta_key) {
                $meta_key = preg_replace('/[^\w-]/', '', $meta_key['meta_key']);

                if(in_array($meta_key, $meta_keys_to_exclude) || (substr( $meta_key, 0, 7 ) === "_oembed")) {
                    continue;
                }

                $meta_keys_rearranged[] = $meta_key;
                $tableData['disabled']['meta_' . $meta_key] = $meta_key;
            }

            set_transient( $transient_name, $meta_keys_rearranged, WEEK_IN_SECONDS);
        } else {

            foreach ($woocommerce_quick_order_meta_keys as $key => $meta_key) {
                $tableData['disabled']['meta_' . $meta_key] = $meta_key;
            }
        }
    }

    $atts = wc_get_attribute_taxonomies();
    if(!empty($atts)) {
        foreach ($atts as $value) {
            $tableData['enabled']['attr-' . $value->attribute_name] = $value->attribute_label;
        }
    }


    global $weLaunchLicenses;
    if( (isset($weLaunchLicenses['woocommerce-quick-order']) && !empty($weLaunchLicenses['woocommerce-quick-order'])) || (isset($weLaunchLicenses['woocommerce-plugin-bundle']) && !empty($weLaunchLicenses['woocommerce-plugin-bundle'])) ) {
        $args['display_name'] = '<span class="dashicons dashicons-yes-alt" style="color: #9CCC65 !important;"></span> ' . $args['display_name'];
    } else {
        $args['display_name'] = '<span class="dashicons dashicons-dismiss" style="color: #EF5350 !important;"></span> ' . $args['display_name'];
    }

    $framework::setArgs( $opt_name, $args );


    $framework::setSection( $opt_name, array(
        'title'  => __( 'Quick Order', 'woocommerce-quick-order' ),
        'id'     => 'general',
        'desc'   => __( 'Need support? Please use the comment function on codecanyon.', 'woocommerce-quick-order' ),
        'icon'   => 'el el-home',
    ) );

    $framework::setSection( $opt_name, array(
        'title'      => __( 'General', 'woocommerce-quick-order' ),
        'desc'       => __( 'To get auto updates please <a href="' . admin_url('tools.php?page=welaunch-framework') . '">register your License here</a>.', 'woocommerce-quick-order' ),
        'id'         => 'general-settings',
        'subsection' => true,
        'fields'     => array(
            array(
                'id'       => 'enable',
                'type'     => 'switch',
                'title'    => __( 'Enable', 'woocommerce-quick-order' ),
                'default'  => 1,
            ),
            array(
                'id'       => 'redirectShowMessage',
                'type'     => 'checkbox',
                'title'    => __( 'Redirect / Show Message after add to cart', 'woocommerce-quick-order' ),
                'default'  => 0,
            ),
            array(
                'id'       => 'oldThemeSupport',
                'type'     => 'checkbox',
                'title'    => __( 'Old Theme support', 'woocommerce-quick-order' ),
                'subtitle' => __( 'Enable this when attributes do not show in cart.', 'woocommerce-quick-order' ),
                'default'  => 0,
            ),
        )
    ));

    $framework::setSection( $opt_name, array(
        'title'      => __( 'Data to Show', 'woocommerce-quick-order' ),
        'desc'       => __( 'Configure the table.', 'woocommerce-quick-order' ),
        'id'         => 'data',
        'subsection' => true,
        'fields'     => array(
            array(
                'id'      => 'dataToShowData',
                'type'    => 'sorter',
                'title'   => 'Variation Data',
                'subtitle'    => 'Reorder, enable or disable data fields.<br><br>CB = Checkbox<br>QT = Quantity<br><br>* PDF Export requires our <a href="https://www.welaunch.io/en/product/woocommerce-print-products/" target="_blank">WooCommerce Print Products (PDF) plugin</a>.<br>** Enquiry requires our <a href="https://www.welaunch.io/en/product/woocommerce-catalog-mode/" target="_blank">Catalog Mode Plugin</a><br>*** Wishlist requires our <a href="https://www.welaunch.io/en/product/woocommerce-wishlist/" target="_blank">Wishlist Plugin</a>.',
                'options' => $tableData,
            ),
            array(
                'id'       => 'tableMetaData',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Meta Data Support ', 'woocommerce-quick-order' ),
                'subtitle'    => __( 'This will list all meta keys in the data above. After enabling you have to reload the settings page.', 'woocommerce-quick-order' ),
                'default'  => 0,
            ),
                array(
                    'id'       => 'tableMetaDataTexts',
                    'type'     => 'multi_text',
                    'title'    => __( 'Meta Data Key Texts ', 'woocommerce-quick-order' ),
                    'subtitle'    => __( 'Set custom meta key names for the table header. First is the key, next the name and split the values with |. An example: _regular_price|Regular Price', 'woocommerce-quick-order' ),
                    'default'  => array(
                        '_regular_price|Regular Price'
                    ),
                    'required' => array('tableMetaData','equals','1'),
                ),
            array(
                'id'       => 'lightboxEnable',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Lightbox', 'woocommerce-quick-order' ),
                'default'  => 0,
            ),
            array(
                'id'       => 'dataToShowShowQuantity',
                'type'     => 'checkbox',
                'title'    => __( 'Show Quantity Field', 'woocommerce-quick-order' ),
                'subtitle' => __( 'Show the Quantity field for Add to Cart', 'woocommerce-quick-order' ),
                'default'  => 0
            ),
            array(
                'id'       => 'dataToShowShowShortDescriptionBelowName',
                'type'     => 'checkbox',
                'title'    => __( 'Short description below Name', 'woocommerce-quick-order' ),
                'subtitle' => __( 'Show Short description below the product name.', 'woocommerce-quick-order' ),
                'default'  => 0
            ),
        )
    ));

    $framework::setSection( $opt_name, array(
        'title'      => __( 'Datatables', 'woocommerce-quick-order' ),
        'desc'       => __( 'Configure the datatables.', 'woocommerce-quick-order' ),
        'id'         => 'datatables',
        'subsection' => true,
        'fields'     => array(
            array(
                'id'       => 'datatablesEnable',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Datatables', 'woocommerce-quick-order' ),
                'default'  => 1,
            ),
            array(
                'id'       => 'datatablesLanguage',
                'type'     => 'select',
                'title'    => __('Datatables Language', 'woocommerce-quick-order'),
                'subtitle' => __('Set a language for the datatable.', 'woocommerce-quick-order'),
                'default'  => 'English',
                'options'  => array( 
                    'Afrikaans' => __('Afrikaans', 'woocommerce-quick-order'),
                    'Albanian' => __('Albanian', 'woocommerce-quick-order'),
                    'Amharic' => __('Amharic', 'woocommerce-quick-order'),
                    'Arabic' => __('Arabic', 'woocommerce-quick-order'),
                    'Armenian' => __('Armenian', 'woocommerce-quick-order'),
                    'Azerbaijan' => __('Azerbaijan', 'woocommerce-quick-order'),
                    'Bangla' => __('Bangla', 'woocommerce-quick-order'),
                    'Basque' => __('Basque', 'woocommerce-quick-order'),
                    'Belarusian' => __('Belarusian', 'woocommerce-quick-order'),
                    'Bulgarian' => __('Bulgarian', 'woocommerce-quick-order'),
                    'Catalan' => __('Catalan', 'woocommerce-quick-order'),
                    'Chinese-traditional' => __('traditional', 'woocommerce-quick-order'),
                    'Chinese' => __('Chinese', 'woocommerce-quick-order'),
                    'Croatian' => __('Croatian', 'woocommerce-quick-order'),
                    'Czech' => __('Czech', 'woocommerce-quick-order'),
                    'Danish' => __('Danish', 'woocommerce-quick-order'),
                    'Dutch' => __('Dutch', 'woocommerce-quick-order'),
                    'English' => __('English', 'woocommerce-quick-order'),
                    'Estonian' => __('Estonian', 'woocommerce-quick-order'),
                    'Filipino' => __('Filipino', 'woocommerce-quick-order'),
                    'Finnish' => __('Finnish', 'woocommerce-quick-order'),
                    'French' => __('French', 'woocommerce-quick-order'),
                    'Galician' => __('Galician', 'woocommerce-quick-order'),
                    'Georgian' => __('Georgian', 'woocommerce-quick-order'),
                    'German' => __('German', 'woocommerce-quick-order'),
                    'Greek' => __('Greek', 'woocommerce-quick-order'),
                    'Gujarati' => __('Gujarati', 'woocommerce-quick-order'),
                    'Hebrew' => __('Hebrew', 'woocommerce-quick-order'),
                    'Hindi' => __('Hindi', 'woocommerce-quick-order'),
                    'Hungarian' => __('Hungarian', 'woocommerce-quick-order'),
                    'Icelandic' => __('Icelandic', 'woocommerce-quick-order'),
                    'Indonesian-Alternative' => __('Alternative', 'woocommerce-quick-order'),
                    'Indonesian' => __('Indonesian', 'woocommerce-quick-order'),
                    'Irish' => __('Irish', 'woocommerce-quick-order'),
                    'Italian' => __('Italian', 'woocommerce-quick-order'),
                    'Japanese' => __('Japanese', 'woocommerce-quick-order'),
                    'Kazakh' => __('Kazakh', 'woocommerce-quick-order'),
                    'Korean' => __('Korean', 'woocommerce-quick-order'),
                    'Kyrgyz' => __('Kyrgyz', 'woocommerce-quick-order'),
                    'Latvian' => __('Latvian', 'woocommerce-quick-order'),
                    'Lithuanian' => __('Lithuanian', 'woocommerce-quick-order'),
                    'Macedonian' => __('Macedonian', 'woocommerce-quick-order'),
                    'Malay' => __('Malay', 'woocommerce-quick-order'),
                    'Mongolian' => __('Mongolian', 'woocommerce-quick-order'),
                    'Nepali' => __('Nepali', 'woocommerce-quick-order'),
                    'Norwegian-Bokmal' => __('Bokmal', 'woocommerce-quick-order'),
                    'Norwegian-Nynorsk' => __('Nynorsk', 'woocommerce-quick-order'),
                    'Pashto' => __('Pashto', 'woocommerce-quick-order'),
                    'Persian' => __('Persian', 'woocommerce-quick-order'),
                    'Polish' => __('Polish', 'woocommerce-quick-order'),
                    'Portuguese-Brasil' => __('Brasil', 'woocommerce-quick-order'),
                    'Portuguese' => __('Portuguese', 'woocommerce-quick-order'),
                    'Romanian' => __('Romanian', 'woocommerce-quick-order'),
                    'Russian' => __('Russian', 'woocommerce-quick-order'),
                    'Serbian' => __('Serbian', 'woocommerce-quick-order'),
                    'Sinhala' => __('Sinhala', 'woocommerce-quick-order'),
                    'Slovak' => __('Slovak', 'woocommerce-quick-order'),
                    'Slovenian' => __('Slovenian', 'woocommerce-quick-order'),
                    'Spanish' => __('Spanish', 'woocommerce-quick-order'),
                    'Swahili' => __('Swahili', 'woocommerce-quick-order'),
                    'Swedish' => __('Swedish', 'woocommerce-quick-order'),
                    'Tamil' => __('Tamil', 'woocommerce-quick-order'),
                    'telugu' => __('telugu', 'woocommerce-quick-order'),
                    'Thai' => __('Thai', 'woocommerce-quick-order'),
                    'Turkish' => __('Turkish', 'woocommerce-quick-order'),
                    'Ukrainian' => __('Ukrainian', 'woocommerce-quick-order'),
                    'Urdu' => __('Urdu', 'woocommerce-quick-order'),
                    'Uzbek' => __('Uzbek', 'woocommerce-quick-order'),
                    'Vietnamese' => __('Vietnamese', 'woocommerce-quick-order'),
                    'Welsh' => __('Welsh', 'woocommerce-quick-order'),
                ),
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesPaging',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Paging', 'woocommerce-quick-order' ),
                'default'  => 0,
                'required' => array('datatablesEnable','equals','1'),
            ),
           array(
                'id'       => 'datatablesPageLength',
                'type'     => 'spinner',
                'title'    => __( 'Default Paging length', 'woocommerce-quick-order' ),
                'subtitle'    => __( 'Make sure you add this default value to the length menu option below.', 'woocommerce-quick-order' ),
                'min'      => '1',
                'step'     => '1',
                'max'      => '999',
                'default'  => '10',
                'required' => array('datatablesPaging','equals','1'),
            ),
            array(
                'id'       => 'datatablesPageLengthMenu',
                'type'     => 'text',
                'title'    => __( 'Page length menu options', 'woocommerce-quick-order' ),
                'subtitle'    => __( 'No spaced between comma and value allowed here.', 'woocommerce-quick-order' ),
                'default'  => '10,25,50,60,75,100',
                'required' => array('datatablesPaging','equals','1'),
            ),
            array(
                'id'       => 'datatablesOrdering',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Ordering', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesOrderColumn',
                'type'     => 'text',
                'title'    => __( 'Default Order Column (starts with 0, not 1)', 'woocommerce-quick-order' ),
                'default'  => '1',
                'required' => array('datatablesOrdering','equals','1'),
            ),
            array(
                'id'       => 'datatablesOrderColumnType',
                'type'     => 'text',
                'title'    => __( 'Default Order Column Type (asc or desc)', 'woocommerce-quick-order' ),
                'default'  => 'asc',
                'required' => array('datatablesOrdering','equals','1'),
            ),
            array(
                'id'       => 'datatablesInfo',
                'type'     => 'checkbox',
                'title'    => __( 'Show Info', 'woocommerce-quick-order' ),
                'default'  => 0,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesFiltering',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Filtering', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesStateSave',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Filter & Search Saving', 'woocommerce-quick-order' ),
                'default'  => 0,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesSearching',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Searching', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
                array(
                    'id'       => 'datatablesSearchingProminent',
                    'type'     => 'checkbox',
                    'title'    => __( 'Search Prominent (full width)', 'woocommerce-quick-order' ),
                    'default'  => 0,
                    'required' => array('datatablesEnable','equals','1'),
                ),
            array(
                'id'       => 'datatablesFixedHeader',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Fixed Header', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesFixedHeaderOffset',
                'type'     => 'spinner',
                'title'    => __( 'Fixed Header Offset', 'woocommerce-quick-order' ),
                'subtitle' => __( 'Leave empty if you have no sticky header e.g. Otherwise specify the height in numbers (without px).', 'woocommerce-quick-order' ),
                'default'  => '0',
                'min'      => '0',
                'step'     => '10',
                'max'      => '500',
                'required' => array('datatablesFixedHeader','equals','1'),
            ),
            array(
                'id'       => 'datatablesFixedFooter',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Fixed Footer', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesFixedFooterOffset',
                'type'     => 'spinner',
                'title'    => __( 'Fixed Footer Offset', 'woocommerce-quick-order' ),
                'subtitle' => __( 'Leave empty if you have no sticky footer e.g. Otherwise specify the height in numbers (without px).', 'woocommerce-quick-order' ),
                'default'  => '0',
                'min'      => '0',
                'step'     => '10',
                'max'      => '500',
                'required' => array('datatablesFixedFooter','equals','1'),
            ),
            array(
                'id'       => 'datatablesColumnSearch',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Column Search', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesScrollCollapse',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Scrolling', 'woocommerce-quick-order' ),
                'default'  => 0,
                 'required' => array('datatablesEnable','equals','1'),
            ),
           array(
                'id'       => 'datatablesScrollY',
                'type'     => 'spinner',
                'title'    => __( 'Scroll Max Height', 'woocommerce-quick-order' ),
                'min'      => '1',
                'step'     => '1',
                'max'      => '99999',
                'default'  => '250',
                'required' => array('datatablesScrollCollapse','equals','1'),
            ),
            array(
                'id'       => 'datatablesResponsive',
                'type'     => 'checkbox',
                'title'    => __( 'Enable Responsive', 'woocommerce-quick-order' ),
                'default'  => 0,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesSDom',
                'type'     => 'text',
                'title'    => __( 'sDOM (leave as it is) Defalult is: W<"clear">Blfrtip', 'woocommerce-quick-order' ),
                'default'  => 'W<"clear">Blfrtip',
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesPrint',
                'type'     => 'checkbox',
                'title'    => __( 'Show Print Export-Button', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesCopyHtml5',
                'type'     => 'checkbox',
                'title'    => __( 'Show Copy Export-Button', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesExcelHtml5',
                'type'     => 'checkbox',
                'title'    => __( 'Show Excel Export-Button', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesCsvHtml5',
                'type'     => 'checkbox',
                'title'    => __( 'Show CSV Export-Button', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
            array(
                'id'       => 'datatablesPdfHtml5',
                'type'     => 'checkbox',
                'title'    => __( 'Show PDF Export-Button', 'woocommerce-quick-order' ),
                'default'  => 1,
                'required' => array('datatablesEnable','equals','1'),
            ),
        )
    ));


    $framework::setSection( $opt_name, array(
        'title'      => __( 'Limitations', 'woocommerce-quick-order' ),
        'desc'       => __( 'Apply Quick Order for specific users / roles.', 'woocommerce-quick-order' ),
        'id'         => 'limitations',
        'subsection' => true,
        'fields'     => array(
            array(
                'id'       => 'applyForUserGroup',
                'type'     => 'select',
                'title'    => __('Apply for users', 'woocommerce-quick-order'), 
                'subtitle' => __('Which user group should be allowed to see the quick order shortcodes.', 'woocommerce-quick-order'),
                'options'  => array(
                    '1' => __('All', 'woocommerce-quick-order' ),
                    '2' => __('Only NOT logged in', 'woocommerce-quick-order' ),
                    '3' => __('Only Logged in', 'woocommerce-quick-order' ),
                ),
                'default'  => '1',
            ),
            array(
                'id'     => 'applyForExcludeUserRoles',
                'type'   => 'select',
                'data'   => 'roles',
                'title'  => __('Exclude User Roles', 'woocommerce-quick-order'),
                'subtitle' => __('Select user roles, where the plugin should NOT apply.', 'woocommerce-quick-order'),
                'multi'    => true,
                'default'  => '',
            ),
        )
    ));

    $framework::setSection( $opt_name, array(
        'title'      => __( 'Advanced settings', 'woocommerce-quick-order' ),
        'desc'       => __( 'Custom stylesheet / javascript.', 'woocommerce-quick-order' ),
        'id'         => 'advanced',
        'subsection' => true,
        'fields'     => array(
            array(
                'id'       => 'wishlistYith',
                'type'     => 'checkbox',
                'title'    => __( 'Use Yith Wishlist Instead', 'woocommerce-quick-order' ),
                'subtitle'    => __( 'Instead of using our own <a href="https://www.welaunch.io/en/product/woocommerce-wishlist/" target="_blank">WooCommerce Wishlist plugin</a>, use Yith plugin.', 'woocommerce-quick-order' ),
                'default'  => 0,
            ),
        )
    ));


    /*
     * <--- END SECTIONS
     */
